/*
Bollen-Curran book;
Factor score estimation using the linear regression technique;
Using the CRIME data:  unconditional linear model results (theta epps equal;

Equation:  
eta = (sigma * lambda` * inv(sigma-yy)*(yi - muy)) + mu(eta)

sigma = {var(alpha)   cov(alpha,beta)
		cov(alpha,beta)  var(beta)  };
*/

proc iml;

*ENTER THE INDIVIDUAL CASE'S Y VALUES HERE;
*case 1;
y1i = {
4.00885,
4.00885,
5.78562,
4.69287};

*case 2;
y2i = {
6.54993,
6.68395,
6.76796,
7.02629};

*case 3;
y3i = {
5.4844,
5.83425,
5.81675,
5.81387};

*case 4;
y4i = {
4.43067,
5.80874,
5.74208,
6.61725};

*case 5;
y5i = {
6.11936,
6.34822,
5.80067,
4.78623};


sigma = {.5274 -.034,
		-.034 .0196};

lambda = {1 0,
		  1 1,
		  1 2,
		  1 3};

lambdat = {1 1 1 1,
		   0 1 2 3};

sigmayy = {
0.626	0.493	0.459	0.424,
0.493	0.577	0.464	0.449,
0.459	0.464	0.567	0.474,
0.424	0.449	0.474	0.596};

muy = {
5.3187,
5.5157,
5.6109,
5.7626};

mueta = {
 5.3379,
 0.1427};

invsigyy = inv(sigmayy);

eta1 = (sigma*(lambdat)*invsigyy*(y1i - muy)) + mueta;
print eta1;

y1i = y1i || lambda;

CREATE a1 FROM y1i;
APPEND FROM y1i;

quit;
proc reg data = a1; model  col1 = col3; run;quit;

