
/*Chapter 8 Example 16 linear model*/
data fit;
 mod_chi=66.58457;   
 mod_df=10; 
 nul_chi=1667.14452;      
 nul_df=10; 
 n=825;

 mod_chi_prob=1-probchi(mod_chi,mod_df);
 nfi=(nul_chi-mod_chi)/(nul_chi);
 tli=((nul_chi/nul_df)-(mod_chi/mod_df))/((nul_chi/nul_df)-1);
 ifi=(nul_chi-mod_chi)/(nul_chi-mod_df);
 rni=((nul_chi-nul_df)-(mod_chi-mod_df))/(nul_chi-nul_df);

 if rni le 1.0 then cfi=rni; else
 if rni gt 1.0 then cfi=1.0; else
 cfi=0;

 if (mod_chi-mod_df) le 0 then rmsea=0; else
 rmsea=sqrt((mod_chi-mod_df)/(mod_df*(n-1)));

 if 1-probchi(mod_chi,mod_df) ge .05 then nc_l=0; else
 nc_l=cnonct(mod_chi,mod_df,.95);

 if 1-probchi(mod_chi,mod_df) ge .95 then nc_u=0; else
 nc_u=cnonct(mod_chi,mod_df,.05);

 rmsea_lo=sqrt(nc_l/((n-1)*mod_df));
 rmsea_hi=sqrt(nc_u/((n-1)*mod_df));

 drop nc_l nc_u;

run;
proc print; var mod_df mod_chi mod_chi_prob rmsea rmsea_lo rmsea_hi ifi tli; run;

/*Chapter 8 Example 16 freed loading model*/
data fit;
 mod_chi=37.68248;   
 mod_df=7; 
 nul_chi=1667.14452;      
 nul_df=10; 
 n=825;

 mod_chi_prob=1-probchi(mod_chi,mod_df);
 nfi=(nul_chi-mod_chi)/(nul_chi);
 tli=((nul_chi/nul_df)-(mod_chi/mod_df))/((nul_chi/nul_df)-1);
 ifi=(nul_chi-mod_chi)/(nul_chi-mod_df);
 rni=((nul_chi-nul_df)-(mod_chi-mod_df))/(nul_chi-nul_df);

 if rni le 1.0 then cfi=rni; else
 if rni gt 1.0 then cfi=1.0; else
 cfi=0;

 if (mod_chi-mod_df) le 0 then rmsea=0; else
 rmsea=sqrt((mod_chi-mod_df)/(mod_df*(n-1)));

 if 1-probchi(mod_chi,mod_df) ge .05 then nc_l=0; else
 nc_l=cnonct(mod_chi,mod_df,.95);

 if 1-probchi(mod_chi,mod_df) ge .95 then nc_u=0; else
 nc_u=cnonct(mod_chi,mod_df,.05);

 rmsea_lo=sqrt(nc_l/((n-1)*mod_df));
 rmsea_hi=sqrt(nc_u/((n-1)*mod_df));

 drop nc_l nc_u;

run;
proc print; var mod_df mod_chi mod_chi_prob rmsea rmsea_lo rmsea_hi ifi tli; run;

/*Chapter 8 Example 16 quadratic model*/
data fit;
 mod_chi=11.74592 ;   
 mod_df=6; 
 nul_chi=1667.14452;      
 nul_df=10; 
 n=825;

 mod_chi_prob=1-probchi(mod_chi,mod_df);
 nfi=(nul_chi-mod_chi)/(nul_chi);
 tli=((nul_chi/nul_df)-(mod_chi/mod_df))/((nul_chi/nul_df)-1);
 ifi=(nul_chi-mod_chi)/(nul_chi-mod_df);
 rni=((nul_chi-nul_df)-(mod_chi-mod_df))/(nul_chi-nul_df);

 if rni le 1.0 then cfi=rni; else
 if rni gt 1.0 then cfi=1.0; else
 cfi=0;

 if (mod_chi-mod_df) le 0 then rmsea=0; else
 rmsea=sqrt((mod_chi-mod_df)/(mod_df*(n-1)));

 if 1-probchi(mod_chi,mod_df) ge .05 then nc_l=0; else
 nc_l=cnonct(mod_chi,mod_df,.95);

 if 1-probchi(mod_chi,mod_df) ge .95 then nc_u=0; else
 nc_u=cnonct(mod_chi,mod_df,.05);

 rmsea_lo=sqrt(nc_l/((n-1)*mod_df));
 rmsea_hi=sqrt(nc_u/((n-1)*mod_df));

 drop nc_l nc_u;

run;
proc print; var mod_df mod_chi mod_chi_prob rmsea rmsea_lo rmsea_hi ifi tli; run;


/*Chapter 8 Example 19 covarying disturbances model*/
data fit;
 mod_chi=34.361;   
 mod_df=15; 
 nul_chi=832.705;      
 nul_df=36; 
 n=166;

 mod_chi_prob=1-probchi(mod_chi,mod_df);
 nfi=(nul_chi-mod_chi)/(nul_chi);
 tli=((nul_chi/nul_df)-(mod_chi/mod_df))/((nul_chi/nul_df)-1);
 ifi=(nul_chi-mod_chi)/(nul_chi-mod_df);
 rni=((nul_chi-nul_df)-(mod_chi-mod_df))/(nul_chi-nul_df);

 if rni le 1.0 then cfi=rni; else
 if rni gt 1.0 then cfi=1.0; else
 cfi=0;

 if (mod_chi-mod_df) le 0 then rmsea=0; else
 rmsea=sqrt((mod_chi-mod_df)/(mod_df*(n-1)));

 if 1-probchi(mod_chi,mod_df) ge .05 then nc_l=0; else
 nc_l=cnonct(mod_chi,mod_df,.95);

 if 1-probchi(mod_chi,mod_df) ge .95 then nc_u=0; else
 nc_u=cnonct(mod_chi,mod_df,.05);

 rmsea_lo=sqrt(nc_l/((n-1)*mod_df));
 rmsea_hi=sqrt(nc_u/((n-1)*mod_df));

 drop nc_l nc_u;

run;
proc print; var mod_df mod_chi mod_chi_prob rmsea rmsea_lo rmsea_hi ifi tli; run;


/*Chapter 8 Example 19 method factor*/
data fit;
 mod_chi=43.942;
 mod_df=18; 
 nul_chi=832.705;      
 nul_df=36; 
 n=166;

 mod_chi_prob=1-probchi(mod_chi,mod_df);
 nfi=(nul_chi-mod_chi)/(nul_chi);
 tli=((nul_chi/nul_df)-(mod_chi/mod_df))/((nul_chi/nul_df)-1);
 ifi=(nul_chi-mod_chi)/(nul_chi-mod_df);
 rni=((nul_chi-nul_df)-(mod_chi-mod_df))/(nul_chi-nul_df);

 if rni le 1.0 then cfi=rni; else
 if rni gt 1.0 then cfi=1.0; else
 cfi=0;

 if (mod_chi-mod_df) le 0 then rmsea=0; else
 rmsea=sqrt((mod_chi-mod_df)/(mod_df*(n-1)));

 if 1-probchi(mod_chi,mod_df) ge .05 then nc_l=0; else
 nc_l=cnonct(mod_chi,mod_df,.95);

 if 1-probchi(mod_chi,mod_df) ge .95 then nc_u=0; else
 nc_u=cnonct(mod_chi,mod_df,.05);

 rmsea_lo=sqrt(nc_l/((n-1)*mod_df));
 rmsea_hi=sqrt(nc_u/((n-1)*mod_df));

 drop nc_l nc_u;

run;
proc print; var mod_df mod_chi mod_chi_prob rmsea rmsea_lo rmsea_hi ifi tli; run;




/*Chapter 8 Example 19  constrained covariance*/
data fit;
 mod_chi= 215.986 
 mod_df=24; 
 nul_chi=832.705;      
 nul_df=36; 
 n=166;

 mod_chi_prob=1-probchi(mod_chi,mod_df);
 nfi=(nul_chi-mod_chi)/(nul_chi);
 tli=((nul_chi/nul_df)-(mod_chi/mod_df))/((nul_chi/nul_df)-1);
 ifi=(nul_chi-mod_chi)/(nul_chi-mod_df);
 rni=((nul_chi-nul_df)-(mod_chi-mod_df))/(nul_chi-nul_df);

 if rni le 1.0 then cfi=rni; else
 if rni gt 1.0 then cfi=1.0; else
 cfi=0;

 if (mod_chi-mod_df) le 0 then rmsea=0; else
 rmsea=sqrt((mod_chi-mod_df)/(mod_df*(n-1)));

 if 1-probchi(mod_chi,mod_df) ge .05 then nc_l=0; else
 nc_l=cnonct(mod_chi,mod_df,.95);

 if 1-probchi(mod_chi,mod_df) ge .95 then nc_u=0; else
 nc_u=cnonct(mod_chi,mod_df,.05);

 rmsea_lo=sqrt(nc_l/((n-1)*mod_df));
 rmsea_hi=sqrt(nc_u/((n-1)*mod_df));

 drop nc_l nc_u;

run;
proc print; var mod_df mod_chi mod_chi_prob rmsea rmsea_lo rmsea_hi ifi tli; run;

/*Chapter 8 Example 19  table 8.7-8.9*/
data fit;
 mod_chi= 35.901; 
 mod_df=16; 
 nul_chi=832.705;      
 nul_df=36; 
 n=166;

 mod_chi_prob=1-probchi(mod_chi,mod_df);
 nfi=(nul_chi-mod_chi)/(nul_chi);
 tli=((nul_chi/nul_df)-(mod_chi/mod_df))/((nul_chi/nul_df)-1);
 ifi=(nul_chi-mod_chi)/(nul_chi-mod_df);
 rni=((nul_chi-nul_df)-(mod_chi-mod_df))/(nul_chi-nul_df);

 if rni le 1.0 then cfi=rni; else
 if rni gt 1.0 then cfi=1.0; else
 cfi=0;

 if (mod_chi-mod_df) le 0 then rmsea=0; else
 rmsea=sqrt((mod_chi-mod_df)/(mod_df*(n-1)));

 if 1-probchi(mod_chi,mod_df) ge .05 then nc_l=0; else
 nc_l=cnonct(mod_chi,mod_df,.95);

 if 1-probchi(mod_chi,mod_df) ge .95 then nc_u=0; else
 nc_u=cnonct(mod_chi,mod_df,.05);

 rmsea_lo=sqrt(nc_l/((n-1)*mod_df));
 rmsea_hi=sqrt(nc_u/((n-1)*mod_df));

 drop nc_l nc_u;

run;
proc print; var mod_df mod_chi mod_chi_prob rmsea rmsea_lo rmsea_hi ifi tli; run;
 
